#ifndef __CONSOLE_H
#define __CONSOLE_H

#include <string>
#include <gdk/gdk.h>

using namespace std;

/* comportare:
	- este creata o singura data, in programul principal
	- diverse clase care au nevoie, varsa mesaje in ea
	- cand este vizibila, afiseaza ultimele 100 de mesaje stranse
	- are buton de salvare in fisier
	- poate salva automat in fisier
	design:
	
	++++++++++++++<>
	+ mesaje     +<>
	+ colorate   +<>
	++++++++++++++<>
	close     save
	
*/
class Window;
class SizeW;

class Console
{
private:
	int _lines;
	Window _window;
	SizeW _sw;
	
	void setColor(GdkColor *, int, int, int);
	
public:
	GdkColor *_fatal;
	GdkColor *_severe;
	GdkColor *_major;
	GdkColor *_minor;
	GdkColor *_warning;
	GdkColor *_normal;
	GdkColor *_information;

	Console(int lines=5000);
	~Console();
		
	void addText(const string &, GdkColor *);
	void show();
	void hide();
	int size();
	void setSize(int);
	SizeW* getSizeW();
};

#endif
