#include "GObject.h"
#include "SNMPObject.h"
#include "general.h"
#include "Window.h"
#include "SizeW.h"
#include "Poll.h"
#include "DrawingArea.h"
#include "Console.h"

SNMPObject::SNMPObject(const string &name, const string &host, const string &community)
{
	_host = host;
	_name = name;
	_community = community;
	_value = 0;
}

void SNMPObject::addPoll(Poll *p)
{
	_poll.push_back(p);
}

int SNMPObject::getWorst()
{
	int max=-1;
	int max_idx=-1;
	if(_poll.size() == 0)
		return 0; //daca nu avem polluri, intoarcem OK
	for(int x=0; x<_poll.size(); x++)
	{
		long val = _poll[x]->getValue();
		
		if(val>max)
		{
			max=val;
			max_idx = x;
		}
		if(val == -1) return val;
	}
	if(max > 100) //de vreme ce nu a ramas -1, inseamna ca chiar (E) un poll
	{
		max=100;
	}
	
	return max;
}

string SNMPObject::getName()
{
	return _name;
}

string SNMPObject::getHost()
{
	return _host;
}

SNMPObject::~SNMPObject()
{
	for(int x=0; x<_poll.size(); x++)
		delete _poll[x];
}
