#include "GObject.h"
#include "SNMPObject.h"
#include "DrawingArea.h"
#include "SNMPRouter.h"

SNMPRouter::SNMPRouter(const string &name, const string &host, const string &community, int x1, int y1, GdkFont *font):
	SNMPObject(name, host, community)
{
	_x1=x1;
	_y1=y1;
	_font=font;
	_first=true;
}

void SNMPRouter::draw(DrawingArea *d)
{
	int cvalue = (255*_value)/100;
	if(cvalue>=0)
	{
		d->circle(1, _x1-8, _y1-8, 16, 0,0,0);
		d->circle(1, _x1-7, _y1-7, 14, cvalue, 255-cvalue, 0);
	}
	else
	{
		d->circle(1, _x1-8, _y1-8, 16, 0,0,0);
		d->circle(1, _x1-6, _y1-6, 12, 255, 255, 255);
	}

	if(_first)
	{
		d->text(_x1-8, _y1-12, (char *)_name.c_str(), 0, 0, 0, _font);
		_first=false;
	}
}

void SNMPRouter::update()
{
	_value=getWorst();
}

bool SNMPRouter::inRange(double x, double y)
{
	double dist = sqrt( (x-_x1)*(x-_x1) + (y-_y1)*(y-_y1) );
	if(dist <= 14)
		return true;
	else
		return false;
}

string SNMPRouter::getState()
{
	string retval="";
	retval += _name;
	return retval;
}

SNMPRouter::~SNMPRouter()
{
	gdk_font_unref(_font);
}
