#include "Window.h"
#include <assert.h>
#include "GObject.h"
#include <gtk/gtk.h>
#include <string.h>
#include <iostream.h>

Window::Window(int x, int y)
{
	GtkWidget *window,*vbox;
	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(GTK_WIDGET(window),x,y);
	gtk_container_border_width(GTK_CONTAINER(window),1);
	gtk_window_set_policy(GTK_WINDOW(window),TRUE,TRUE,FALSE);
	
	//fereastra contine in mod implicit un box vertical
	vbox=gtk_vbox_new(FALSE,1);
	gtk_container_add(GTK_CONTAINER(window),vbox);
	
	addWidget("toplevel", window);
	addWidget("vbox", vbox);
}

GtkWidget* Window::getWidget(const string &name)
{
	int x;
	for(x = 0; x < _objects.size(); x++)
		if( _objects[x]->getName() == name) break;
	
	if(x < _objects.size())
		return _objects[x]->getWidget();
	else
		return NULL;
}

void Window::addWidget(const string & name, GtkWidget *w)
{
	GObject *tmp = new GObject(name, w);
	
	int x;
	for(x=0; x< _objects.size();  x++)
		if( _objects[x]->getName() == name) break;
	
	if(x < _objects.size())
		throw("Object name already used");
	else
		_objects.push_back(tmp);
}	

void Window::addWidget(GObject *g)
{
	int x;
	for(x=0; x< _objects.size();  x++)
		if( _objects[x]->getName() == g->getName() ) break;
	
	if(x < _objects.size())
		throw("Object name already used");
	else
		_objects.push_back(g);
}	

void Window::draw()
{
	gtk_widget_show_all(getWidget("toplevel"));
}

Window::~Window()
{
	for(int i=_objects.size()-1; i>=0; i--)
		delete _objects[i];
}
